import { system } from '@minecraft/server';
import { ConfiguratorSub } from '../configuratorOptions';
import { Database } from '../db';
import { ActionForm, ModalForm } from '../form_func';
import { uiManager } from '../uis';
import icons from '../icons';
import { warps } from '../warpsapi';
export default function () {
  return new ConfiguratorSub("§dWarp Editor", "azalea_icons/WarpEditor").setCallback(player => {
    let form = new ActionForm();
    form.title("Warp Editor / Home");
    form.body("Welcome to the new warp editor. You cant create warps here, but you can edit info associated with them!");
    form.button("Exit", null, (player, i) => {});
    for (const warpName of warps.getAllWarpsOld()) {
      form.button(`§d${warpName}`, null, player => {
        let modal = new ModalForm();
        let warp = warps.getDB(warpName);
        modal.title(`Edit ${warp.rotX ? "§dRotation-Preserved" : "§aClassic"} §rwarp`);
        modal.toggle("Hidden (May cause bugs with other features)", warp.hidden ? true : false, (player, state, i) => {});
        modal.textField("Required Tag", "Tag required to use warp", warp.requiredTag ? warp.requiredTag : undefined, (player, text, i) => {});
        modal.textField("Teleport Tag", "Tag used to teleport", warp.teleportTag ? warp.teleportTagw : undefined, (player, text, i) => {});
        let isRotationPreservedWarp = false;
        if (warp.rotX) {
          isRotationPreservedWarp = true;
          modal.textField("Rot§dX", "Rotation X", warp.rotX.toString(), (player, text, i) => {});
          modal.textField("Rot§eY", "Rotation Y", warp.rotY.toString(), (player, text, i) => {});
        }
        modal.textField("Loc§cX", "Location X", warp.x.toString(), (player, text, i) => {});
        modal.textField("Loc§aY", "Location Y", warp.y.toString(), (player, text, i) => {});
        modal.textField("Loc§bZ", "Location Z", warp.z.toString(), (player, text, i) => {});
        modal.show(player, false, (player, response) => {
          if (isRotationPreservedWarp) {
            warps.setHidden(warpName, response.formValues[0]);
            if (response.formValues[1]) {
              warps.setRequiredTag(warpName, response.formValues[1]);
            }
            if (!response.formValues[1]) {
              warps.setRequiredTag(warpName, "");
            }
            if (response.formValues[2]) {
              warps.setTeleportTag(warpName, response.formValues[2]);
            }
            if (!response.formValues[2]) {
              warps.setTeleportTag(warpName, "");
            }
            let warp = warps.warpsDb.get(warpName);
            warp.rotX = parseFloat(response.formValues[3]);
            warp.rotY = parseFloat(response.formValues[4]);
            warp.x = parseFloat(response.formValues[5]);
            warp.y = parseFloat(response.formValues[6]);
            warp.z = parseFloat(response.formValues[7]);
            warps.warpsDb.set(warpName, warp);
          } else {
            warps.setHidden(warpName, response.formValues[0]);
            if (response.formValues[1]) {
              warps.setRequiredTag(warpName, response.formValues[1]);
            }
            if (!response.formValues[1]) {
              warps.setRequiredTag(warpName, "");
            }
            if (response.formValues[2]) {
              warps.setTeleportTag(warpName, response.formValues[2]);
            }
            if (!response.formValues[2]) {
              warps.setTeleportTag(warpName, "");
            }
            let warp = warps.warpsDb.get(warpName);
            warp.x = parseFloat(response.formValues[3]);
            warp.y = parseFloat(response.formValues[4]);
            warp.z = parseFloat(response.formValues[5]);
            warps.warpsDb.set(warpName, warp);
          }
        });
      });
    }
    form.show(player, false, (player, response) => {});
  });
}